#!/usr/bin/perl
#
# This is a little pretty-printer for an IP number list.
# For use with relay-check.pl, for example after running
# relay-check.pl on the mailbox where you have filtered
# the relayed messages to, run:
#
#   grep '^Hello' MAILBOXFILE | list-hosts.pl
#
# This script can also accempt more "cleaned" versions of
# input as shown below.
#
# See the file COPYRIGHT for copyright information.
# (c) David Luyer, 1998.

use strict;

my (%net, $net, $host);

while(<>) {
  chomp;
  if(/^(\d+\.\d+\.\d+)\.(\d+)(:25)?$/ ||
     /^Hello via (\d+\.\d+\.\d+)\.(\d+)(:25)?$/) {
    push @{$net{$1}}, $2;
  }
}

sub bn3 {
  my ($a1, $b1);

  $a =~ /^\d+\.\d+\.(\d+)$/;
  $a1 = $1;
  $b =~ /^\d+\.\d+\.(\d+)$/;
  $b1 = $1;
  $a1 <=> $b1;
}

sub bn {
  $a <=> $b;
}

for $net (sort bn3 keys %net) {
  print $net.": ";
  for $host (sort bn @{$net{$net}}) {
    print "$host ";
  }
  print "\n";
}
